'FFSubmenu=Tools
'FFName=Ordnersuche

'(c) Harald Maeckler, Dsseldorf 2016 - 2018
' ***********************************************************************
' Ordnersuche.vbs (Skript fr FixFoto)  / Suchen von Ordnern
' ***********************************************************************
'
' Version 1.12 vom 17.02.2020	- Variable 'N_Liste' definiert
'								- Updatefunktion an neue Forumssoftware angepasst
' Version 1.11 vom 02.05.2018	- Bug beim Abbruch des Suchlaufs mit <Backspace> behoben
' Version 1.10 vom 29.04.2018	- Vor- und Zurck-Schalten in der Ergebnnisliste per
'									Button oder Tastenkombination Alt + V bzw. Alt + Z
'								- Breiteneinstellung der Ergebnisliste
' Version 1.09 vom 11.01.2017	- Suchlaufdauer wird angezeigt
'								- Bilder des markierten Ordners ber einen Dialog
'									in eine Bilderliste eintragen
' Version 1.08 vom 09.01.2017	- Bug bei ndern des Startverzeichnis behoben
'								- bei Suchergebnis 0 Ordner > Meldung 'kein Ergebnis'
' Version 1.07 vom 08.01.2017	- Breite des Dialogfensters einstellbar
' Version 1.06 vom 08.01.2017	- Meldung 'Bitte warten ..." aufflliger
' Version 1.05 vom 04.01.2017	- Fortschrittsanzeige ersetzt durch Meldung
'									'Bitte warten ...'
' Version 1.04 vom 03.01.2017	- nach Wechsel des Startverzeichnisses wird
'									automatisch Suche gestartet
'								- Fortschrittsanzeige verbessert
'								- Button 'Abbrechen' umbenannt in 'Schlieen'
'								- PopUp-Texte und Kurzbeschreibung berarbeitet
' Version 1.03 vom 02.01.2017	- Abfangen diverser Fehlermglichkeiten
'								- nach erfolgreicher Suche wird das Skript nicht
'									automatisch beendet
' Version 1.02 vom 05.12.2016	- Sonderfunktionen Umbenenennen und Verschieben
' Version 1.01 vom 03.12.2016	- Format abc\xyz fr Suchbegriff zulssig
' Version 1.00 vom 01.12.2016	- Betaversion
' ***********************************************************************

Option Explicit

'Updatekonstanten und Variable
const SkriptVersion = "1.12"
const SkriptURL = "https://www.ffsf.de/resources/ordnersuche.360/"
Dim UrlVersion,UrlV_Zahl,SkriptV_Zahl,SkriptEnde

'allgemeine Konstanten und Variable
const ForReading = 1, ForWriting = 2
Dim Abbruch,Antwort

'Skriptspezifische Konstanten und Variable
Dim x,xv	'Breitenvergrerung des Dialogfensters (zwischen 0 und 300 / Standard 100)
Dim Ziel,StartVer,SuchText,SuchTextUO,ErgListe
Dim folder,subfolder,n,Anz,pos,Beginn,FolderListe
Dim G_Liste,BildArray
Dim MeldBW,MeldSE,MeldKe,MeldAn,SLende
Dim f,ImageList,OrdnerNeu,OrdnerPfad,OrdnerZiel,OrdnerAktuell,N_Liste
MeldAn = false : SLende = false

const allFolder = false
'bei false wird bei positivem Suchergebnis nicht weiter in der Tiefe gesucht (Standard)
'bei true werden alle Ordner mit dem Suchbegriff im Namen aufgelistet

'Objekte
Dim objFS,WshShell
Set objFS = CreateObject("Scripting.FileSystemObject")
Set WshShell = CreateObject("WScript.Shell")

'Lschroutine
Dim SkriptKill,TempFile	 : SkriptKill = false
Dim SkriptName
const Skript = "Ordnersuche"					'Skriptname
const RegSchluessel = "FF_Ordnersuche"			'Registryschlssel

' ***********************************************************************
call main
Set WshShell = Nothing
Set objFS = Nothing
' ***********************************************************************
Sub main

on error resume next							'Kontrolle ob Skript in FF-Umgebung gestartet wurde
	FF_GetScriptPath
 	if err <> 0 then
		msgbox "Das Skript funktioniert nur in der Programmumgebung von FixFoto!",vbCritical,"Abbruch"
		exit sub
	end if
on error goto 0

if objFS.FileExists(FF_GetScriptPath & "\" & Skript & ".vbs") then
	SkriptName = Skript & ".vbs"
elseif objFS.FileExists(FF_GetScriptPath & "\" & Skript & ".vbe") then
	SkriptName = Skript & ".vbe"
else
	msgbox "Das Skript wurde umbenannt!",vbCritical,"Abbruch"
	exit sub
end if

MeldBW = FF_GetScriptPath & "\MeckiScript\Ordnersuche\BW.png"
MeldSE = FF_GetScriptPath & "\MeckiScript\Ordnersuche\SE.png"
MeldKE = FF_GetScriptPath & "\MeckiScript\Ordnersuche\KE.png"

x = FF_GetProfile (RegSchluessel,"x")
if len(x) = 0 then x = 100

'in die ersten vier Zeilen  + x eintragen
'FF_AddDialog "Ordnersuche",250 +x,226
'FF_AddControl "Ordnersuche","Suchergebnis","GROUP",5,80,240 +x12
'FF_AddControl "Ordnersuche","Suchparameter","GROUP",5,5,240 +x,60
'FF_AddControl "Ordnersuche","ErgListe","LISTBOX",12,100,228 +x,58
'** Start Dialog Ordnersuche **
FF_AddDialog "Ordnersuche",250 +x,226
FF_AddControl "Ordnersuche","Suchergebnis","GROUP",5,80,240 +x,112
FF_AddControl "Ordnersuche","Suchparameter","GROUP",5,5,240 +x,60
FF_AddControl "Ordnersuche","ErgListe","LISTBOX",12,100,228 +x,58
FF_AddControl "Ordnersuche","Startverzeichnis","STATIC",12,16,40,10
FF_AddControl "Ordnersuche","StartVer","SLEDIT",12,26,214,10
FF_SetControlStyle "Ordnersuche","StartVer",2048
FF_AddControl "Ordnersuche","...","BUTTON",230,26,10,10
FF_AddControl "Ordnersuche","Suchbegriff","STATIC",12,40,40,10
FF_AddControl "Ordnersuche","SuchText","SLEDIT",12,50,228,10
FF_AddControl "Ordnersuche","||","STATIC",12,89,228,10
FF_AddControl "Ordnersuche","bei Doppelklick auf einen der Ordner wird","STATIC",31,158,102,8
FF_SetControlStyle "Ordnersuche","bei Doppelklick auf einen der Ordner wird",1
FF_AddControl "Ordnersuche","dieser zum aktuellen Computerverzeichnis","STATIC",31,165,102,8
FF_SetControlStyle "Ordnersuche","dieser zum aktuellen Computerverzeichnis",1
FF_AddControl "Ordnersuche","&Vor","BUTTON",9,177,26,11
FF_AddControl "Ordnersuche","&Zurck","BUTTON",42,177,26,11
FF_AddControl "Ordnersuche","markierten Ordner >>>","STATIC",98,176,59,9
FF_AddControl "Ordnersuche","Strich","STATIC",159,159,1,25
FF_SetControlStyle "Ordnersuche","Strich",17
FF_AddControl "Ordnersuche","Umbenennen","BUTTON",165,158,36,11
FF_AddControl "Ordnersuche","Verschieben","BUTTON",204,158,36,11
FF_AddControl "Ordnersuche","Inhalt in Bilderliste eintragen","BUTTON",165,174,75,11
FF_AddControl "Ordnersuche","?","BUTTON",10,209,11,11
FF_AddControl "Ordnersuche","|","STATIC",24,209,22,11
FF_SetControlStyle "Ordnersuche","|",1
FF_AddControl "Ordnersuche","Update","BUTTON",48,209,33,11
FF_AddControl "Ordnersuche","Meldung","IMAGE",88,208,70,12
FF_AddControl "Ordnersuche","Schlieen","BUTTON",165,209,36,11
FF_AddControl "Ordnersuche","Suchen","BUTTON",204,209,36,11
FF_AddControl "Ordnersuche","&delete","BUTTON",0,0,1,1
FF_AddControl "Ordnersuche","Breiteneinstellung","BUTTON",88,69,75,10
FF_AddControl "Ordnersuche","Abbruch des Suchlaufs mit Backspace-Taste mglich","STATIC",5,195,240,10
FF_SetControlStyle "Ordnersuche","Abbruch des Suchlaufs mit Backspace-Taste mglich",1
'** End Dialog Ordnersuche **

call RegistryLesen

'Tooltips
if Version_OK("3.30.06") then
	FF_SetControlTooltip "Ordnersuche","StartVer", "" &_
						 StartVer
	FF_SetControlTooltip "Ordnersuche","...", "" &_
						 "Startverzeichnis festlegen"
	FF_SetControlTooltip "Ordnersuche","SuchText", "" &_
						 "gesucht werden Ordner mit dem Suchtext im Namen"
	FF_SetControlTooltip "Ordnersuche","Breiteneinstellung", "" &_
						 "Breite der Ergebnisliste"	 & vbNewLine &_
						 "bei Bedarf ndern"
	FF_SetControlTooltip "Ordnersuche","ErgListe", "" &_
						 "bei Doppelklick auf einen der Ordner wird" & vbNewLine &_
						 "dieser zum aktuellen Computerverzeichnis"
	FF_SetControlTooltip "Ordnersuche","&Vor", "" &_
						 "Nchsten Ordner in der Ergebnisliste" & vbNewLine &_
						 "aufrufen (auch mit Alt + V)"
	FF_SetControlTooltip "Ordnersuche","&Zurck", "" &_
						 "Vorherigen Ordner in der Ergebnisliste" & vbNewLine &_
						 "aufrufen (auch mit Alt + Z)"
	FF_SetControlTooltip "Ordnersuche","Umbenennen", "" &_
						 "den markierten Ordner umbenennen"
	FF_SetControlTooltip "Ordnersuche","Verschieben", "" &_
						 "den markierten Ordner verschieben"
	FF_SetControlTooltip "Ordnersuche","Inhalt in Bilderliste eintragen", "" &_
						 "alle Bilder des markierten Ordners in" & vbNewLine &_
						 "eine zu whlende Bilderliste eintragen"
	FF_SetControlTooltip "Ordnersuche","?", "" &_
						 "Anzeige der Kurzbeschreibung"
	FF_SetControlTooltip "Ordnersuche","Update", "" &_
						 "Prfung ob eine neue Version vorliegt"
	FF_SetControlTooltip "Ordnersuche","Schlieen", "" &_
						 "Skript beenden"
	FF_SetControlTooltip "Ordnersuche","Suchen", "" &_
						 "Suchen nach Ordner mit Suchbegriff im Namen"
end if

if Version_OK("3.40.52") then FF_SetTooltipDelay 3000
FF_SetDialogTimer "Ordnersuche", 100
FF_ActivateControl "Ordnersuche","&delete"

do
	Abbruch = false
	Select Case FF_ShowDialog ("Ordnersuche")
	Case "TIMER"
		FF_SetDialogTimer "Ordnersuche", 0
		if MeldAn then
			MeldAn = false
			call Suchen
			if SLende then
				FF_SetControl "Ordnersuche" ,"||", "Suchlauf nicht beendet"
				FF_SetControl "Ordnersuche" ,"Meldung",MeldKE
				SLende = false
			end if
		else
			FF_SetControl "Ordnersuche" ,"|", "V " & Skriptversion
	
			SuchTextUO = ""
			pos = instr(SuchText,"\")
			if pos > 0 then
				if len(SuchText) > pos then
					SuchTextUO = trim(mid(SuchText,pos +1))
				end if
				SuchText = trim(left(SuchText,pos -1))
			end if
			
			if objFS.FolderExists(StartVer) and len(trim(SuchText)) > 0 and instr(SuchTextUO,"\") = 0 and Zeichentest(SuchText)	and Zeichentest(SuchTextUO) then
				FF_SetControl "Ordnersuche" ,"Meldung",MeldBW
				call Suchen
				if SLende then
					FF_SetControl "Ordnersuche" ,"||", "Suchlauf nicht beendet"
					FF_SetControl "Ordnersuche" ,"Meldung",MeldKE
					SLende = false
				end if
			else
				FF_SetControl "Ordnersuche" ,"||", "kein Suchlauf erfolgt"
			end if
		end if
	Case "&delete"
		Antwort = msgbox("Soll das Skript " & SkriptName & vbNewline & _
						 "wirklich gelscht werden?", _
						 vbYesNo + vbQuestion,"Sicherheitsabfrage")
		if Antwort = vbYes then
			SkriptKill = true
			exit do
		end if
	Case "..."
		Ziel = FF_EnterPath(false,"Wahl des Startverzeichnis")
		if len(Ziel) > 2 then
			FF_SetControl "Ordnersuche","StartVer",Ziel
			call Werte_auslesen
			call Kontrolle
			if not Abbruch then
				FF_SetControl "Ordnersuche","ErgListe",""
				FF_SetControl "Ordnersuche" ,"Meldung",MeldBW
				MeldAn = true
				FF_SetDialogTimer "Ordnersuche", 100
			else
				FF_SetControl "Ordnersuche" ,"ErgListe", ""
				FF_SetControl "Ordnersuche" ,"||", "kein Suchlauf erfolgt"
				FF_SetControl "Ordnersuche" ,"Meldung",""
			end if
		end if
	Case "Breiteneinstellung"
		do
			xv = InputBox("Wert zwischen 0 und 300 eingeben!","Breiteneinstellung",x)
			if len(xv) = 0 then exit do
			if not IsNumeric(xv) then
				msgbox "Es muss eine Zahl zwischen 0 und 300 eingegeben werden!",vbInformation,"Hinweis"
			else
				if xv *1 = x *1 then
					exit do
				elseif xv *1 < 0 or xv *1 > 300 then
					msgbox "Es muss eine Zahl zwischen 0 und 300 eingegeben werden!",vbInformation,"Hinweis"
				else
					msgbox "Das Skript wird jetzt beendet." & vbNewLine &_
							"Beim nchsten Skriptstart wird die" & vbNewLine &_
							"Breiteneinstellung wirksam.",vbInformation,"Hinweis"
					FF_WriteProfile RegSchluessel,"x",xv
					Abbruch = true : exit do
				end if
			end if
		loop
		if Abbruch then exit do
	Case "ErgListe"
		FF_SetImagePath FF_GetControl ("Ordnersuche","ErgListe")
	Case "&Vor"
		call VorZurueck ("Vor")
	Case "&Zurck"
		call VorZurueck ("Zurueck")
	Case "Umbenennen"
		if len(FF_GetControl("Ordnersuche","ErgListe")) > 0 then 
			call Listenverbindung
			if not Abbruch then
				call Umbenennen
				if not Abbruch then
					FF_SetImagePath	OrdnerNeu
					exit do
				end if
			end if
		end if
	Case "Verschieben"
		if len(FF_GetControl("Ordnersuche","ErgListe")) > 0 then
			call Listenverbindung
			if not Abbruch then
				call Verschieben
				if not Abbruch then
					FF_SetImagePath	OrdnerNeu
					exit do
				end if
			end if
		end if
	Case "Inhalt in Bilderliste eintragen"
		call Listeneintrag
	Case "?"
		WshShell.Popup "" & _
			"Unterhalb des vorgebbaren Startverzeichnisses werden die" & vbNewLine &_
			"Ordner gesucht, die den definierbaren Suchbegriff im Namen" & vbNewLine &_
			"haben. Die gefundenen Ordner werden aufgelistet. Der Such-" & vbNewLine &_
			"vorgang kann mit der Backspace-Taste abgebrochen werden." & vbNewLine & vbNewLine &_
			"Ein Doppelklick mit der linken Maustaste auf einen dieser" & vbNewLine &_
			"Ordner macht diesen zum aktuellen Computerverzeichnis." & vbNewLine &_
			"Alternativ kann man in der Liste vor und zurck schalten" & vbNewLine &_
			"mit den Button 'Vor' bzw. 'Zurck' oder mit Hilfe der" & vbNewLine &_
			"Tastenkombination Alt + V bzw. Alt & Z." & vbNewLine & vbNewLine &_
			"Hinweis:" & vbNewLine &_
			"Fr den Suchbegriff ist das Format abc\xyz zulssig. Es wird" & vbNewLine &_
			"dann nach Unterordnern mit dem Namensbestandteil xyz in" & vbNewLine &_
			"den Ordnern mit dem Namensbestandteil abc gesucht." & vbNewLine & vbNewLine &_
			"Reicht die Breite der Ergebnisliste nicht aus, kann mit dem" & vbNewLine &_
			"Befehl 'Breiteneinstellung' die Dialogfensterbreite ver-" & vbNewLine &_ 
			"grert werden." & vbNewLine & vbNewLine &_
			"Umbenennen und Verschieben" & vbNewLine &_
			"Der markierte Ordner kann umbenannt oder verschoben" & vbNewLine &_
			"werden. Aber Achtung: Bestehen Verbindungen der Dateien" & vbNewLine &_
			"im Ordner zu Bilderlisten, gehen diese verloren. Es erfolgt" & vbNewLine &_
			"ein entsprechender Hinweis mit der Mglichkeit den Vorgang" & vbNewLine &_
			"abzubrechen. Nach dem Umbenennen bzw. Verschieben wird" & vbNewLine &_
			"der manipulierte Ordner zum aktuellen Computerverzeichnis." & vbNewLine &_
			"Das Skript wird anschlieend beendet." & vbNewLine & vbNewLine &_
			"Auch ist es mit dem Befehl 'Inhalt in Bilderliste eintragen'" & vbNewLine &_
			"mglich, alle Bilder in eine Bilderliste einzutragen. Dafr" & vbNewLine &_
			"wird ein Dialog mit diversen Einstellmglichkeiten geffnet." & vbNewLine &_
			"Nach dem Vorgang ist der markierte Ordner das aktuelle Com-" & vbNewLine &_
			"puterverzeichnis." & vbNewLine & vbNewLine &_
			"Mit Bettigung der Tastenkombination Alt + D kann fr das" & vbNewLine &_
			"Skript eine Lschroutine aufgerufen werden." &_
			"",,"Erluterungen",vbInformation
	Case "Update"
		if InternetConnection then
			SkriptEnde = false
			call Update
			if SkriptEnde then exit do
		end if
	Case "Schlieen","CANCEL"
		exit do
	Case "Suchen"
		call Werte_auslesen
		call Kontrolle
		if not Abbruch then
			FF_SetControl "Ordnersuche","ErgListe",""
			FF_SetControl "Ordnersuche" ,"Meldung",MeldBW
			MeldAn = true
			FF_SetDialogTimer "Ordnersuche", 100
		else
			FF_SetControl "Ordnersuche" ,"ErgListe", ""
			FF_SetControl "Ordnersuche" ,"||", "kein Suchlauf erfolgt"
			FF_SetControl "Ordnersuche" ,"Meldung",""
		end if

	End Select
loop

call RegistrySchreiben
FF_CloseDialog ("Ordnersuche")
if SkriptKill then			'ggf. Skript komplett entfernen
	call KillSkript
end if

end sub
'------------------------------------------------------------------------
Sub Suchen

n = 0 : Anz = 0 : SuchText = trim(SuchText)
Folderliste = ""

FF_SetControl "Ordnersuche" ,"||", "Bitte warten ..."
Beginn = Timer

Set folder = objfs.GetFolder(StartVer)
call ShowSubfolder (folder)
if SLende then exit sub

FF_SetControl "Ordnersuche" ,"||", Anz & " Ordner gefunden / durchsucht wurden " & n &_
			  " Ordner / Suchdauer " & FormatNumber(Timer - Beginn,3) & " sec."
if Anz = 0 then
	FF_SetControl "Ordnersuche" ,"Meldung",MeldKE
	FF_EnableControl "Ordnersuche","Umbenennen", false
	FF_EnableControl "Ordnersuche","Verschieben", false
	FF_EnableControl "Ordnersuche","Inhalt in Bilderliste eintragen", false
else 
	FF_SetControl "Ordnersuche" ,"Meldung",MeldSE
	FF_EnableControl "Ordnersuche","Umbenennen", true
	FF_EnableControl "Ordnersuche","Verschieben", true
	FF_EnableControl "Ordnersuche","Inhalt in Bilderliste eintragen", true
end if

End Sub
'------------------------------------------------------------------------
Sub ShowSubfolder(myfolder)
'bei positivem Suchergebnis nicht weiter in der Tiefe suchen

'### Ordnerzhler
n = n +1

'FF_Sleep 5		'zum Testen des Suchlaufabbruchs
'### Abbruch?
if FF_CheckKey() = 8 then 	'8 = Backspace
	Antwort = msgbox(n & " Ordner wurden bisher durchsucht und ca." & Anz & " Ordner gefunden." & vbNewLine & vbNewLine & _
					 "Soll die Suche abgebrochen werden?",vbYesNo or vbQuestion,"Abfrage")
	if Antwort = vbYes then SLende = true
end if

'### Suche
if instr(ucase(myfolder.path),ucase(SuchText)) > 0 then
	if len(SuchTextUO) > 0 then
		if instr(ucase(myfolder.path),ucase(SuchTextUO)) > 0 then
			FF_SetControl "Ordnersuche","ErgListe",myfolder.path
			Anz = Anz +1
			if len(FolderListe) = 0 then
				FolderListe = myfolder.path
			else
				FolderListe = FolderListe & vbNewLine & myfolder.path
			end if
			if not allFolder then exit sub
		end if
	else
		FF_SetControl "Ordnersuche","ErgListe",myfolder.path
		Anz = Anz +1
		if len(FolderListe) = 0 then
			FolderListe = myfolder.path
		else
			FolderListe = FolderListe & vbNewLine & myfolder.path
		end if
		if not allFolder then exit sub
	end if
end if

on error resume next
for each subfolder In myfolder.subfolders
	if SLende then exit sub
	if err = 0 then call ShowSubfolder (subfolder)
next
on error goto 0
	
End Sub
'------------------------------------------------------------------------
Sub VorZurueck (Richtung)
Dim A_FolderListe,FolderAktiv

FolderAktiv = FF_GetControl ("Ordnersuche","ErgListe")
A_FolderListe = split(FolderListe,vbNewLine)

for n = 0 to ubound(A_FolderListe)
	if A_FolderListe(n) = FolderAktiv then exit for
next

if Richtung = "Vor" and n < ubound(A_FolderListe) then
	FF_SetControl "Ordnersuche","ErgListe",A_FolderListe(n +1)
	FF_SetImagePath A_FolderListe(n +1)
end if
	
if Richtung = "Zurueck" and n > 0 then
	FF_SetControl "Ordnersuche","ErgListe",A_FolderListe(n -1)
	FF_SetImagePath A_FolderListe(n -1)
end if

End Sub
'------------------------------------------------------------------------
Sub Listenverbindung

Set f = objFS.OpenTextFile(FF_GetFFPathEx(1) & "\FixFotoImageList.ini", ForReading,True)
ImageList = f.ReadAll
f.Close

if instr(ImageList,FF_GetControl("Ordnersuche","ErgListe")) > 0 then
	Antwort = msgbox("Mindestens eins der Bilder im Ordner" & vbNewLine &_
					 "hat Verbindungen zu Bilderlisten." & vbNewLine &_
					 "Diese Verbindungen gehen verloren.",vbExclamation + vbOkCancel,"Abbruch?")
	if Antwort = vbCancel then Abbruch = true : exit sub
end if

End Sub
'------------------------------------------------------------------------
Sub Umbenennen

OrdnerPfad = FF_GetControl("Ordnersuche","ErgListe")
pos = InStrRev(OrdnerPfad,"\")
if pos = 0 then Abbruch = true : exit sub

OrdnerAktuell = mid(OrdnerPfad,pos +1)
OrdnerNeu = InputBox("Neuer Ordnername:","Eingabe",OrdnerAktuell)
if len(OrdnerNeu) = 0 then Abbruch = true : exit sub

if not Zeichentest(OrdnerNeu) then
	msgbox "Der Suchtext darf keins der Zeichen \ / : * ? < > | enthalten!",vbExclamation,"Meldung"
	Abbruch = true : exit sub
end if

if objFS.FolderExists(OrdnerNeu) then
	msgbox "Ein Ordner mit dem neuen Namen existiert bereits!",vbInformation,"Abbruch"
	Abbruch = true : exit sub
end if

OrdnerNeu = left(OrdnerPfad,pos) & OrdnerNeu
if objFS.FolderExists(OrdnerNeu) then
	msgbox "Ein Ordner mit dem neuen Namen existiert bereits!",vbInformation,"Abbruch"
	Abbruch = true : exit sub
end if

objfs.MoveFolder OrdnerPfad,OrdnerNeu

End Sub
'------------------------------------------------------------------------
Sub Verschieben

OrdnerPfad = FF_GetControl("Ordnersuche","ErgListe")
pos = InStrRev(OrdnerPfad,"\")
if pos = 0 then Abbruch = true : exit sub

OrdnerAktuell = mid(OrdnerPfad,pos +1)

FF_SetCurrentPath OrdnerPfad
OrdnerZiel = FF_EnterPath(false,"Wahl des Startverzeichnis")
if len(OrdnerZiel) = 0 then Abbruch = true : exit sub

OrdnerNeu = OrdnerZiel & "\" & OrdnerAktuell
if objFS.FolderExists(OrdnerNeu) then
	msgbox "Ein Ordner mit dem Namen existiert" & vbNewLine &_
		   "bereits an der gewhlten Stelle!",vbInformation,"Abbruch"
	Abbruch = true : exit sub
end if

if instr(ucase(OrdnerNeu),ucase(OrdnerPfad)) > 0 then
	msgbox "Der Ordner kann nicht unter sich" & vbNewLine &_
		   "selbst angeordnet werden!",vbInformation,"Abbruch"
	Abbruch = true : exit sub
end if

objfs.MoveFolder OrdnerPfad,OrdnerNeu

End Sub
'------------------------------------------------------------------------
Sub Listeneintrag
Dim Bilder,ListArray,element
Dim anzBliste,anzBges,flagAblage

FF_SetImagePath FF_GetControl ("Ordnersuche","ErgListe")
Bilder = FF_GetSelection(0)
if len(Bilder) = 0 then
	msgbox "Der markierte Ordner enthlt keine Bilder!",vbInformation,"Hinweis"
	Abbruch = true : exit sub
end if
BildArray = split(Bilder,vbNewLine)

'** Start Dialog Bildereintrag **
FF_AddDialog "Bildereintrag",163,96
FF_AddControl "Bildereintrag","Bilderliste als Ablageort whlen","GROUP",5,5,151,54
FF_AddControl "Bildereintrag","Abbruch","BUTTON",74,79,33,11
FF_AddControl "Bildereintrag","Liste","COMBO",11,19,138,10
FF_AddControl "Bildereintrag","?","BUTTON",9,79,11,11
FF_AddControl "Bildereintrag","Bilder ablegen","BUTTON",109,79,42,11
FF_AddControl "Bildereintrag","||","STATIC",8,64,144,10
FF_SetControlStyle "Bildereintrag","||",1
FF_AddControl "Bildereintrag","|||","STATIC",13,32,116,10
FF_AddControl "Bildereintrag","Listeninhalt lschen","BUTTON",53,44,54,11
FF_AddControl "Bildereintrag","Neue Liste","BUTTON",109,44,42,11
FF_AddControl "Bildereintrag","Liste anzeigen","BUTTON",9,44,42,11
'** End Dialog Bildereintrag **

ListArray = split(FF_IListGetLists,vbNewLine)	'vorhandene Bilderlisten
for each element in ListArray
	FF_SetControl "Bildereintrag","Liste",element
next

for each element in ListArray
	if FF_IListGetCurrentList = element then	'aktuelle Bilderliste
		FF_SetControl "Bildereintrag","Liste",element
		exit for
	end if
next

anzBliste = FF_IListGetCount(FF_GetControl("Bildereintrag","Liste"))
if anzBliste = 0 then FF_EnableControl "Bildereintrag","Listeninhalt lschen", false
anzBges = ubound(BildArray) +1
if anzBges   = 0 then FF_EnableControl "Bildereintrag","Bilder ablegen", false

'Tooltips
if Version_OK("3.30.06") then
	FF_SetControlTooltip "Bildereintrag","Listeninhalt lschen", "" &_
						 "Alle Bilder in der ausgewhlten Liste" & vbNewLine & _
						 "werden nach einer Sicherheitsabfrage gelscht."
	FF_SetControlTooltip "Bildereintrag","Neue Liste", "" &_
						 "Es wird eine neue, leere Liste" & vbNewLine & "mit vorgebbarem Namen angelegt."
	FF_SetControlTooltip "Bildereintrag","?", "" &_
						 "Erluterungen"
	FF_SetControlTooltip "Bildereintrag","Abbruch", "" &_
						 "Das Skript wird wieder beendet."
	FF_SetControlTooltip "Bildereintrag","Bilder ablegen", "" &_
						 "Gesammelte Bilder werden in die angezeigte" & vbNewLine & _
						 "Bilderliste bertragen."
	FF_SetControlTooltip "Bildereintrag","Liste anzeigen", "" &_
						 "Die ausgewhlte Liste wird angezeigt"
end if

if not Version_OK("3.40.70") then FF_EnableControl "Bildereintrag","Liste anzeigen",false
if Version_OK("3.40.52") then FF_SetTooltipDelay 3000

FF_SetDialogTimer "Bildereintrag", 100

Do
	Select Case FF_ShowDialog ("Bildereintrag")

	Case "TIMER"
		FF_SetDialogTimer "Bildereintrag", 0
		FF_SetControl "Bildereintrag" ,"|||","Die gewhlte Liste enthlt " & anzBliste & " Bild(er)"
		FF_SetControl "Bildereintrag" ,"||",anzBges & "  Bild(er) knnen der gewhlte Liste hinzugefgt werden"
	Case "Liste"
		anzBliste = FF_IListGetCount(FF_GetControl("Bildereintrag","Liste"))
		if anzBliste = 0 then 
			FF_EnableControl "Bildereintrag","Listeninhalt lschen", false
		else
			FF_EnableControl "Bildereintrag","Listeninhalt lschen", true
		end if
		FF_SetControl "Bildereintrag" ,"|||","Die gewhlte Liste enthlt " & anzBliste & " Bild(er)"
	Case "Liste anzeigen"
		FF_IListShow FF_GetControl("Bildereintrag","Liste")
	Case "Listeninhalt lschen"
		G_Liste = FF_GetControl("Bildereintrag","Liste")
		Antwort = msgbox ("Sollen wirklich alle Bilder in der Liste" & vbNewLine &_
						  "   '" & G_Liste & "'" & vbNewLine &_
						  "gelscht werden?", vbQuestion + vbYesNo,"Sicherheitsabfrage")
		if Antwort = vbYes then
			do while FF_IListGetCount(G_Liste) > 0
				FF_IListDeleteIndex G_Liste,0
			loop
			FF_IListUpdate G_Liste
			anzBliste = 0
			FF_SetControl "Bildereintrag" ,"|||",anzBliste & " Bild(er) enthlt die ausgewhlte Liste"
			FF_EnableControl "Bildereintrag","Listeninhalt lschen", false
		end if
	Case "Neue Liste"
		N_Liste = InputBox("Name der neuen Liste?","Neue Liste","")
		if len(N_Liste) > 0 then
			if instr(ucase(vbNewLine & FF_IListGetLists & vbNewLine),ucase(N_Liste)) > 0 then
				msgbox "Die Liste '" & N_Liste & "' gibt es bereits!",vbInformation,"Hinweis"
			else
				FF_IListCreate N_Liste
				G_Liste = N_Liste : anzBliste = 0
				FF_SetControl "Bildereintrag","Liste",G_Liste
				FF_SetControl "Bildereintrag","Liste",G_Liste
				FF_SetControl "Bildereintrag" ,"|||",anzBliste & " Bild(er) enthlt die ausgewhlte Liste"
				FF_EnableControl "Bildereintrag","Listeninhalt lschen", false				
			end if
		end if
	Case "?"
		WshShell.Popup "" & _
			"Zur Ablage kann eine Bilderliste ausgewhlt werden. Die dort" & vbNewLine &_
			"bereits abgelegte Anzahl von Bildern wird angezeigt." & vbNewLine &_
			"Man kann sich die Liste anzeigen lassen, ggf. den Listeninhalt" & vbNewLine &_
			"lschen oder eine neue Liste anlegen." & vbNewLine & vbNewLine &_
			"Mit dem Befehl 'Bilder Ablegen' werden alle Bilder des mar-" & vbNewLine &_
			"kierten Ordners in der gewhlten Bilderliste abgelegt." &_
			"",,"Erluterungen",vbInformation
	Case "Bilder ablegen"
		G_Liste = FF_GetControl("Bildereintrag","Liste")
		flagAblage = true
		exit do
	Case "Abbruch","CANCEL"
		exit do
	Case Else
	End Select
loop

FF_CloseDialog ("Bildereintrag")
if flagAblage then call Ablage

End Sub
'------------------------------------------------------------------------
Sub Ablage
'Bilder aus dem markierten Ordner werden in der ausgewhlten Bilderliste abgelegt

Dim element,Anz,m,BilderInListe,msg
Dim anzBinL : anzBinL = 0		'Anzahl Bilder, die bertragen wurden
Dim anzDinL : anzDinL = 0		'Anzahl Duplikate in der Sammelliste

'in der gewhlten Bilderliste vorhanden Bilder sammeln
for m = 0 to FF_IListGetCount(G_Liste) -1
	if len(BilderInListe) = 0 then
		BilderInListe = FF_IListGetFile(G_Liste,m)
	else
		BilderInListe = BilderInListe & vbNewLine & FF_IListGetFile(G_Liste,m)
	end if
next

'Bilder aus dem markierten Ordner in die ausgewhlte Bilderliste bertragen
for each element in BildArray
	if len(element) > 0 then
		if instr(BilderInListe,element) = 0 then
			FF_IListInsertFile G_Liste,element,-1
			anzBinL = anzBinL +1
		else
			anzDinL = anzDinL +1
		end if
	end if
next

FF_IListUpdate G_Liste
FF_IListSave G_Liste

if anzBinL = 0 then
	msg =	"Es wurde kein Bild bertragen, da es sich bei den" & vbNewLine &_
			"gesammelten Bildern um Duplikate handelt."
else
	msg = 	"Es wurde(n) " & anzBinL & " Bild(er) in die Bilderliste" & vbNewLine &_
			"'" & G_Liste & "' bertragen."
	if anzDinL > 0 then
		msg = 	msg & vbNewLine & vbNewLine &_
				anzDinL & " in der Sammlung enthaltene(s) Duplikat(e)" & vbNewLine &_
				"wurde nicht bertragen."
	end if
end if

msgbox msg,vbInformation,"Hinweis"

End Sub
'------------------------------------------------------------------------
Sub Werte_auslesen

StartVer = FF_GetControl ("Ordnersuche","StartVer")
SuchText = FF_GetControl ("Ordnersuche","SuchText")

End Sub
'------------------------------------------------------------------------
Sub Kontrolle

if len(StartVer) = 0 then
	msgbox "Es muss ein Startverzeichnis definiert werden!",vbExclamation,"Meldung"
	Abbruch = true : exit sub
end if

if not objFS.FolderExists(StartVer) then
	msgbox "Das angegebene Startverzeichnis existiert nicht!",vbExclamation,"Meldung"
	Abbruch = true : exit sub
end if

if len(trim(SuchText)) = 0 then
	msgbox "Es muss ein Suchbegriff definiert werden!",vbExclamation,"Meldung"
	Abbruch = true : exit sub
end if

SuchTextUO = ""
pos = instr(SuchText,"\")
if pos > 0 then
	if len(SuchText) > pos then
		SuchTextUO = trim(mid(SuchText,pos +1))
	end if
	SuchText = trim(left(SuchText,pos -1))
end if

if instr(SuchTextUO,"\") > 0 then
	msgbox "Im Suchbegriff darf nur einmal '\' verwendet werden!",vbExclamation,"Meldung"
	Abbruch = true : exit sub
end if

if not Zeichentest(SuchText) or not Zeichentest(SuchTextUO) then
	msgbox "Der Suchtext darf keins der Zeichen \ / : * ? < > | enthalten!",vbExclamation,"Meldung"
	Abbruch = true : exit sub
end if

End Sub
'------------------------------------------------------------------------
Sub RegistryLesen
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\ & RegSchluessel

'### Werte auslesen

StartVer = FF_GetProfile (RegSchluessel,"StartVer")
SuchText = FF_GetProfile (RegSchluessel,"SuchText")

'### Werte eintragen

FF_SetControl "Ordnersuche","StartVer",StartVer
FF_SetControl "Ordnersuche","SuchText",SuchText

End Sub
'------------------------------------------------------------------------
Sub RegistrySchreiben
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\ & RegSchluessel

call Werte_Auslesen

'Werte schreiben
FF_WriteProfile RegSchluessel,"StartVer",StartVer
FF_WriteProfile RegSchluessel,"SuchText",SuchText

End Sub
'------------------------------------------------------------------------
'************************************************************************
'Internetverbindung ?
'************************************************************************
'------------------------------------------------------------------------
Function InternetConnection
 
Dim obj
Set obj = GetObject("winmgmts:Win32_PingStatus.address='" & "google.de" & "'")

if IsNull(obj.StatusCode) or obj.StatusCode <> 0 Then
   msgbox "Keine Internetverbindung!",vbInformation,"Hinweis"
   InternetConnection = false
else
   InternetConnection = true
end if
 
End Function
'------------------------------------------------------------------------
'************************************************************************
'Update-Funktion
'************************************************************************
'------------------------------------------------------------------------
Sub Update

call Versionsermittlung_url

if not Abbruch then
	SkriptV_Zahl = Replace(SkriptVersion,".","") *1
	
	if UrlV_Zahl = SkriptV_Zahl then
		msgbox "Die Version " & SkriptVersion & " ist aktuell!",vbInformation,"Versionsmeldung"
	elseif SkriptV_Zahl < UrlV_Zahl then
		Antwort = msgbox("Die Skriptversion " & SkriptVersion & " ist nicht mehr aktuell!" & vbNewLine &_
				"Es steht die Version " & UrlVersion & " zum Download bereit." & vbNewLine & vbNewLine & _
				"Soll die Downloadseite aufgerufen werden?",vbQuestion + vbYesNo,"Versionsmeldung")
		if Antwort = vbYes then
			on error resume next
			WshShell.Run SkriptUrl,1,false
			if err <> 0 then
				msgbox "Die Downloadseite wurde nicht gefunden!",vbExclamation,"Hinweis"
			else
				SkriptEnde = true
			end if
			on error goto 0
		end if
	else
		msgbox 	"Es liegt ein Fehler in den Versionsangaben vor." & vbNewLine &_
				"Die Skriptversion " & SkriptVersion & " ist grer als die auf" & vbNewLine &_
				"der Downloadseite angegebene Version " & UrlVersion & ".",vbInformation,"Fehlermeldung"
	end if
end if

End Sub
'------------------------------------------------------------------------
Sub Versionsermittlung_url

Dim Inhalt,Start,Zeit,pos1,pos2,n
Dim xml, Fehler
Fehler = false

on error resume next
Set xml = CreateObject("Microsoft.XMLHTTP")
xml.Open "Get",SkriptUrl,false
xml.Send

Inhalt = xml.responseText

if err > 0 then
	Fehler = true
else
	'Version suchen und anzeigen
	pos1 = instr(Inhalt,"Version:")
	if pos1 > 0 then
		pos2 = instr(pos1 ,Inhalt,"<br")
'		if pos2 = 0 then pos2 = pos1 + 14	'#### ?
		if pos2 > 0 then
			UrlVersion = trim(mid(Inhalt,pos1,pos2-pos1))
			'Msgbox "Aktuell ist die " & UrlVersion,vbInformation,"Information"
		else
			Fehler = true
		end if
	else
		Fehler = true
	end if
end if

Set xml = nothing

if Fehler then
	msgbox  "Die Versionsangabe wurde nicht gefunden!" & vbNewLine &_
			"Mglicherweise funktioniert der Internetaufruf nicht." & vbNewLine & vbNewLine & _
			"Am besten nochmal probieren!",vbExclamation,"Fehlermeldung"
	Abbruch = true
	exit sub
end if

'Version als Zahl
pos1 = instr(UrlVersion," ")
if pos1 = 0 then pos1 = 7
UrlVersion = trim(mid(UrlVersion,pos1+1))
UrlV_Zahl = Replace(UrlVersion,".","") *1

End Sub
'------------------------------------------------------------------------
'************************************************************************
'Lschroutine
'************************************************************************
'------------------------------------------------------------------------
Sub KillSkript
'Skript mit allen Komponenten entfernen

Dim SPfad

'### FixFotoScript.ini bereinigen
TempFile = FF_GetFFPathEx(1) & "\FixFotoScript.ini"
if objFS.FileExists(TempFile) then
	call IniBereinigung
	if Abbruch then exit sub
else
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht gefunden werden." & vbNewLine & _
			"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	exit sub
end if

'### zip-Archiv auf Wunsch sichern, dann lschen
TempFile = FF_GetScriptPath & "\" & objFS.GetBaseName(Skriptname) & ".zip"
if objFS.FileExists(TempFile) then
	Antwort = msgbox("Soll das Archiv " & objFS.GetBaseName(Skriptname) & ".zip" & _
			 " gesichert werden?",vbYesNo + vbQuestion,"Sicherheitskopie")
	if Antwort = vbYes then
		SPfad = FF_EnterPath(true,"Wo soll die Sicherheitskopie angelegt werden?")
		if SPfad = "" then
			msgbox "Das Lschen des Skripts wird abgebrochen!",vbExclamation,"Hinweis"
			exit sub
		end if
		SPfad = SPfad & "\" & objFS.GetBaseName(Skriptname) & ".zip"
		objFS.CopyFile Tempfile, SPfad, true
	end if
	objFS.DeleteFile TempFile,true
end if

'### Skriptdatei lschen
TempFile = FF_GetScriptPath & "\" & Skriptname
objFS.DeleteFile TempFile,true

'### evtl. beigepackte bzw. erzeugte Dateien lschen
'TempFile = """" & FF_GetScriptPath & "\SetDate\SetDate.pdf" & """"			'Dateien
'if objFS.FileExists(TempFile) then objFS.DeleteFile TempFile,true

'### evtl. beigepackte bzw. erzeugte Ordner lschen
'TempFile = FF_GetScriptPath & "\MeckiScript\SetDate"						'Ordner
'if objFS.FolderExists(TempFile) then objFS.DeleteFolder TempFile,true

'### ggf. Registry-Daten lschen
TempFile = "HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\" & RegSchluessel & "\"
WshShell.RegDelete(TempFile)

'### Fertigmeldung
msgbox "Das Skript" & Skriptname & vbNewLine & "wurde mit allen Komponenten gelscht!" & vbNewLine & _
	   "Es wird empfohlen die 'Automatische Skriptkonfiguration' aufzurufen.",vbExclamation,"Hinweis"

End Sub
'------------------------------------------------------------------------
Sub IniBereinigung
'FixFotoScript.ini - Bereinigung

Dim Zeile, zNr,Anfang, Ende, DateiTmp, ZielZeile, tmpString
DateiTmp =  FF_GetFFPathEx(1) & "\FixFotoScript.tmp"

'### Wo befindet sich der Eintrag zum Skript?
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if tmpString = "[Script]" then Anfang = zNr
	if tmpString = "File=.\" & Skriptname then
		Ende = zNr
		exit do	
	end if
loop 
Zeile.Close

if Ende <= Anfang then
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht bereinigt werden." & vbNewLine & _
		"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	Abbruch = true
	exit sub
end if

'### Zeilen ohne skriptbezogene Zeilen in DateiTmp bertragen
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)
Set ZielZeile  = objFS.CreateTextFile(DateiTmp, True)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if zNr < Anfang or zNr > Ende then
		ZielZeile.WriteLine tmpString
	end if
loop 

Zeile.Close
ZielZeile.Close

'### Umkopieren von DateiTmp nach FixFotoScript.ini (TempFile)
objFS.CopyFile DateiTmp, TempFile, True
objFS.DeleteFile (DateiTmp)

End Sub
'------------------------------------------------------------------------
'************************************************************************
'Standard-Funktionen
'************************************************************************
'------------------------------------------------------------------------
Function Version_OK(MinVersion)
dim VersNr

 VersNr=split(MinVersion,".")
 Version_OK=FF_GetMajor * 1000 + FF_GetMinor + FF_GetBuild / 1000 >=_
     		VersNr(0) * 1000 + VersNr(1) + VersNr(2) / 1000

End Function
'------------------------------------------------------------------------
Function Zeichentest (strDName)
Dim z,Y
   z = split("\,/,:,*,?,<,>,|" & chr(34),",")
   for each y in z
      if instr(strDName,y) > 0 then
         Zeichentest = false
         exit Function
      end if
   next
   Zeichentest = true
End Function
'------------------------------------------------------------------------
